# generated by datamodel-codegen:
#   filename:  data_room_action.json

from __future__ import annotations

from enum import Enum
from typing import Any, Mapping, Optional, Sequence, Union

from pydantic import BaseModel, ConfigDict, Field, RootModel, conint


class Kind(Enum):
    media = 'media'


class ProvisionBaseAudiencePolicyIds(BaseModel):
    demographicsPolicyId: Optional[str] = None
    embeddingsPolicyId: Optional[str] = None
    matchingPolicyId: str
    segmentsPolicyId: Optional[str] = None


class DataRoomAction9(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    provisionBaseAudiencePolicyIds: ProvisionBaseAudiencePolicyIds


class DataRoomAction10(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deprovisionBaseAudiencePolicyIds: Mapping[str, Any]


class ProvisionSeedAudiencePolicyIds(BaseModel):
    audiencesPolicyId: str


class DataRoomAction11(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    provisionSeedAudiencePolicyIds: ProvisionSeedAudiencePolicyIds


class DataRoomAction12(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deprovisionSeedAudiencePolicyIds: Mapping[str, Any]


class DeleteCustomAudience(BaseModel):
    audienceId: str
    forceDeletePrerequisites: bool


class DataRoomAction14(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deleteCustomAudience: DeleteCustomAudience


class GetAudiencePrerequisites(BaseModel):
    audienceId: str


class DataRoomAction15(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getAudiencePrerequisites: GetAudiencePrerequisites


class Kind53(Enum):
    BASE = 'BASE'


class AudienceReference13(BaseModel):
    kind: Kind53


class Kind54(Enum):
    CUSTOM = 'CUSTOM'


class AudienceReference14(BaseModel):
    id: str
    kind: Kind54


class Kind55(Enum):
    SEED = 'SEED'


class AudienceReference15(BaseModel):
    audienceType: str
    kind: Kind55


class AudienceReference(
    RootModel[Union[AudienceReference13, AudienceReference14, AudienceReference15]]
):
    root: Union[AudienceReference13, AudienceReference14, AudienceReference15]


class BooleanOp(Enum):
    AND = 'AND'
    OR = 'OR'


class CombineOperator(Enum):
    INTERSECT = 'INTERSECT'
    UNION = 'UNION'
    DIFF = 'DIFF'


class Kind56(Enum):
    LOOKALIKE = 'LOOKALIKE'


class CustomAudienceDefinition13(BaseModel):
    excludeSeedAudience: Optional[bool] = None
    kind: Kind56
    reach: conint(ge=0)
    sourceRef: AudienceReference


class Kind57(Enum):
    RULE_BASED = 'RULE_BASED'


class Kind58(Enum):
    REMARKETING = 'REMARKETING'


class FilterOperator(Enum):
    CONTAINS_ANY_OF = 'CONTAINS_ANY_OF'
    CONTAINS_NONE_OF = 'CONTAINS_NONE_OF'
    CONTAINS_ALL_OF = 'CONTAINS_ALL_OF'
    EMPTY = 'EMPTY'
    NOT_EMPTY = 'NOT_EMPTY'


class SeedAudienceReference(BaseModel):
    audienceType: str


class AudienceFilter(BaseModel):
    attribute: str
    operator: FilterOperator
    values: Optional[Sequence[str]] = None


class AudienceFilters(BaseModel):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class CustomAudienceDefinition15(BaseModel):
    kind: Kind58
    seedAudienceRef: SeedAudienceReference


class AudienceCombinator(BaseModel):
    filters: Optional[AudienceFilters] = None
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition14(BaseModel):
    combine: Optional[Sequence[AudienceCombinator]] = None
    filters: Optional[AudienceFilters] = None
    kind: Kind57
    sourceRef: AudienceReference


class CustomAudienceDefinition(
    RootModel[
        Union[
            CustomAudienceDefinition13,
            CustomAudienceDefinition14,
            CustomAudienceDefinition15,
        ]
    ]
):
    root: Union[
        CustomAudienceDefinition13,
        CustomAudienceDefinition14,
        CustomAudienceDefinition15,
    ]


class CreateCustomAudience(BaseModel):
    definition: CustomAudienceDefinition
    name: str
    sharedWith: Sequence[str]


class DataRoomAction13(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    createCustomAudience: CreateCustomAudience


class UpdateCustomAudience(BaseModel):
    audienceId: str
    definition: Optional[CustomAudienceDefinition] = None
    name: Optional[str] = None
    sharedWith: Optional[Sequence[str]] = None


class DataRoomAction16(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    updateCustomAudience: UpdateCustomAudience


class DataRoomAction(
    RootModel[
        Union[
            DataRoomAction9,
            DataRoomAction10,
            DataRoomAction11,
            DataRoomAction12,
            DataRoomAction13,
            DataRoomAction14,
            DataRoomAction15,
            DataRoomAction16,
        ]
    ]
):
    root: Union[
        DataRoomAction9,
        DataRoomAction10,
        DataRoomAction11,
        DataRoomAction12,
        DataRoomAction13,
        DataRoomAction14,
        DataRoomAction15,
        DataRoomAction16,
    ] = Field(..., title='DataRoomAction')
