# generated by datamodel-codegen:
#   filename:  data_room_action.json

from __future__ import annotations

from typing import Any, Mapping, Optional, Sequence, Union

from typing_extensions import Literal, NotRequired, TypedDict


class ProvisionBaseAudiencePolicyIds(TypedDict):
    demographicsPolicyId: NotRequired[Optional[str]]
    embeddingsPolicyId: NotRequired[Optional[str]]
    matchingPolicyId: str
    segmentsPolicyId: NotRequired[Optional[str]]


class DataRoomAction9(TypedDict):
    kind: Literal['media']
    provisionBaseAudiencePolicyIds: ProvisionBaseAudiencePolicyIds


class DataRoomAction10(TypedDict):
    kind: Literal['media']
    deprovisionBaseAudiencePolicyIds: Mapping[str, Any]


class ProvisionSeedAudiencePolicyIds(TypedDict):
    audiencesPolicyId: str


class DataRoomAction11(TypedDict):
    kind: Literal['media']
    provisionSeedAudiencePolicyIds: ProvisionSeedAudiencePolicyIds


class DataRoomAction12(TypedDict):
    kind: Literal['media']
    deprovisionSeedAudiencePolicyIds: Mapping[str, Any]


class DeleteCustomAudience(TypedDict):
    audienceId: str
    forceDeletePrerequisites: bool


class DataRoomAction14(TypedDict):
    kind: Literal['media']
    deleteCustomAudience: DeleteCustomAudience


class GetAudiencePrerequisites(TypedDict):
    audienceId: str


class DataRoomAction15(TypedDict):
    kind: Literal['media']
    getAudiencePrerequisites: GetAudiencePrerequisites


class AudienceReference13(TypedDict):
    kind: Literal['BASE']


class AudienceReference14(TypedDict):
    id: str
    kind: Literal['CUSTOM']


class AudienceReference15(TypedDict):
    audienceType: str
    kind: Literal['SEED']


AudienceReference = Union[AudienceReference13, AudienceReference14, AudienceReference15]


BooleanOp = Literal['AND', 'OR']


CombineOperator = Literal['INTERSECT', 'UNION', 'DIFF']


class CustomAudienceDefinition13(TypedDict):
    excludeSeedAudience: NotRequired[Optional[bool]]
    kind: Literal['LOOKALIKE']
    reach: int
    sourceRef: AudienceReference


FilterOperator = Literal[
    'CONTAINS_ANY_OF', 'CONTAINS_NONE_OF', 'CONTAINS_ALL_OF', 'EMPTY', 'NOT_EMPTY'
]


class SeedAudienceReference(TypedDict):
    audienceType: str


class AudienceFilter(TypedDict):
    attribute: str
    operator: FilterOperator
    values: NotRequired[Sequence[str]]


class AudienceFilters(TypedDict):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class CustomAudienceDefinition15(TypedDict):
    kind: Literal['REMARKETING']
    seedAudienceRef: SeedAudienceReference


class AudienceCombinator(TypedDict):
    filters: NotRequired[Optional[AudienceFilters]]
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition14(TypedDict):
    combine: NotRequired[Sequence[AudienceCombinator]]
    filters: NotRequired[Optional[AudienceFilters]]
    kind: Literal['RULE_BASED']
    sourceRef: AudienceReference


CustomAudienceDefinition = Union[
    CustomAudienceDefinition13, CustomAudienceDefinition14, CustomAudienceDefinition15
]


class CreateCustomAudience(TypedDict):
    definition: CustomAudienceDefinition
    name: str
    sharedWith: Sequence[str]


class DataRoomAction13(TypedDict):
    kind: Literal['media']
    createCustomAudience: CreateCustomAudience


class UpdateCustomAudience(TypedDict):
    audienceId: str
    definition: NotRequired[Optional[CustomAudienceDefinition]]
    name: NotRequired[Optional[str]]
    sharedWith: NotRequired[Sequence[str]]


class DataRoomAction16(TypedDict):
    kind: Literal['media']
    updateCustomAudience: UpdateCustomAudience


DataRoomAction = Union[
    DataRoomAction9,
    DataRoomAction10,
    DataRoomAction11,
    DataRoomAction12,
    DataRoomAction13,
    DataRoomAction14,
    DataRoomAction15,
    DataRoomAction16,
]
